RoomWordsSample
================

This repository contains the finished sample code for the
[Architecture Components codelab](https://codelabs.developers.google.com/codelabs/android-room-with-a-view/index.html?index=..%2F..%2Findex#0) in Java on the master branch and in Kotlin for the [Architecture Components Kotlin codelab](https://codelabs.developers.google.com/codelabs/android-room-with-a-view-kotlin) on the [kotlin](https://github.com/googlecodelabs/android-room-with-a-view/tree/kotlin) branch.

Introduction
------------

In May 2017 Google released the Architecture Components libraries.
Each library manages and simplifies aspects of data persistence and the
UI component lifecycle. Together, the libraries encourage a modular
app architecture that results in reduced complexity and less code.

This sample shows how to use the libraries to build
a complete basic app that implements the recommended architecture
and can be used as a template for further explorations.


Pre-requisites
--------------

* Android Studio 3.0 or later and you know how to use it.

* Make sure Android Studio is updated, as well as your SDK and Gradle.
Otherwise, you may have to wait for a while until all the updates are done.

* A device or emulator that runs SDK level 20

You need to be solidly familiar with the Java programming language,
object-oriented design concepts, and Android Development Fundamentals.
In particular:

* RecyclerView and Adapters
* SQLite database and the SQLite query language
* Threading and ExecutorService
* It helps to be familiar with software architectural patterns that separate
  data from the user interface, such as MVP or MVC. This codelab implements the
  architecture defined in the
  [Guide to App Architecture](
  https://developer.android.com/topic/libraries/architecture/guide.html)

Getting Started
---------------

1. [Install Android Studio](https://developer.android.com/studio/install.html),
if you don't already have it.
2. Download the sample.
2. Import the sample into Android Studio.
3. Build and run the sample.

License
-------

Copyright 2019 Google, Inc.

All image and audio files (including *.png, *.jpg, *.svg, *.mp3, *.wav
and *.ogg) are licensed under the CC BY 4.0 license. All other files are
licensed under the Apache 2 license.

Licensed to the Apache Software Foundation (ASF) under one or more contributor
license agreements.  See the LICENSE file distributed with this work for
additional information regarding copyright ownership.  The ASF licenses this
file to you under the Apache License, Version 2.0 (the "License"); you may not
use this file except in compliance with the License.  You may obtain a copy of
the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the
License for the specific language governing permissions and limitations under
the License.
